<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

    <v-container
      v-if="readonly"
    >
      <v-row dense align="center"
        v-for="(p, index) in entries"
        :key="index"
        :class="p.additionalClass"
      >
        <v-col>
          <span v-if="p.icon" style="padding-right:5px">
            <v-icon color="primary" small v-if="p.highlight">{{p.icon}}</v-icon>
            <v-icon v-else small>{{p.icon}}</v-icon>
          </span>
          <template v-if="p.formatted" v-html="formatted">        
            <span class="esy-label-normal">{{p.key}}</span>
            <div v-html="p.formatted"></div>
          </template>
          <template v-else>
            <span class="esy-label-normal">{{p.key}}: </span> {{p.value}}
          </template>
        </v-col>
      </v-row>
    </v-container>

    <v-container v-else>
      <v-row dense 
          v-for="(p, index) in entries"
          :key="index"
      >
          <v-col cols="3" >
            <v-text-field 
              :label=keyLabel 
              :hint=keyHint
              v-model="p.key"
              :error-messages="p.keyErrorMessages"
              :error="p.keyErrorMessages.length>0"
              v-on:changed="validate()"
              :rules="keyRules"
            ></v-text-field>
          </v-col>
          <v-col cols="8" >
            <v-textarea 
              v-if="multilineValue"
              auto-grow
              rows=1
              :label=valueLabel 
              :hint=valueHint
              :error-messages="p.valueErrorMessages"
              :error="p.valueErrorMessages.length>0"
              v-model="p.value"
            ></v-textarea>
            <v-text-field
              v-else
              :label=valueLabel 
              :hint=valueHint
              :error-messages="p.valueErrorMessages"
              :error="p.valueErrorMessages.length>0"
              v-model="p.value"
            ></v-text-field>
          </v-col>
          <v-col cols="1" align="center">
            <v-icon 
              v-on:click="deleteEntry(index)"
            >mdi-delete</v-icon>
          </v-col>
      </v-row>
      <v-row dense>
        <v-col cols="12">
          <v-btn
            small
            v-on:click="addEntry()"
            depressed
          >
            <v-icon>mdi-plus</v-icon>
            {{addButtonLabel}}
          </v-btn>
        </v-col>
      </v-row>
    </v-container>

</template>

<script>

export default {

  name: 'KeyValues',

  props: {
    readonly: {
      type: Boolean,
      default: true
    },
    addButtonLabel: {
      type: String,
      default: "Add item"
    },
    keyLabel: {
      type: String,
      default: "Name"
    },
    valueLabel: {
      type: String,
      default: "Value"
    },
    keyHint: {
      type: String,
      default: "The name of the property"
    },
    valueHint: {
      type: String,
      default: "The value of the property"
    },
    entries: {
      type: Array,
      default: function() {return []}
    },
    reservedKeys: {
      type: Array,
      default: function() {return []}
    },
    invalidChars: {
      type: String,
      default: ""
    },
    optionalValue: {
      type: Boolean,
      default: false
    },
    keyRules: {
      type: Array,
      default: function() {return []}
    },
    multilineValue: {
      type: Boolean,
      default: false
    }
  },
  
  watch: {
    entries: {
      deep: true,
      handler: function() {
        this.validate();
      }
    }

  },  
  
  methods: {
  
    validate: function() {

      var keys = {};
      for(var j in this.entries) {
        var k = this.entries[j].key;
        if(keys[k]==null)
          keys[k]=0;
        keys[k]++;
      }    

      for(var i in this.entries) {
        var keyMessages = [];
        var valueMessages = [];
        var entry = this.entries[i];
        
        // check for reserved keys
        if(this.reservedKeys.includes(entry.key))
          keyMessages.push("'"+entry.key+"' cannot be used here");

        // check for empty keys
        if(entry.key == null || entry.key.length==0)
          keyMessages.push(this.keyLabel + " cannot be empty");

        // check for empty values
        if(!this.optionalValue && (entry.value == null || entry.value.length==0)) {
          valueMessages.push(this.valueLabel + " cannot be empty");
        }
          
        // check for duplicate keys
        if(keys[entry.key]>1)
          keyMessages.push("Duplicate entry: '"+entry.key+"'");

        // check for whitespace
        if(this.invalidChars && entry.key) {
          for(var c in this.invalidChars) {
            var character = this.invalidChars.charAt(c)
            if(entry.key.indexOf(character)>-1)
              keyMessages.push("Invalid character: '"+character+"'");
          }
        }
          
        entry.keyErrorMessages = keyMessages;
        entry.valueErrorMessages = valueMessages;
      }
    },
    
    deleteEntry: function(index) {
      this.entries.splice(index, 1);
    },
    
    addEntry: function() {
      this.entries.push({key:"", value:""});
    }
    
  }

};

</script>
  
<style>

</style>